#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include <limits.h>
#include <qstring.h>
#include <qapplication.h>

#include "optymalizacja.h"
#include "obliczenia.h"
#include "bank.h"
#include "wzory1.h"
#include "wzory2.h"
#include "wzory3.h"

Optymalizacja::Optymalizacja(Obliczenia*obl)
{
	this->obliczenia=obl;
	msg = new QString[33]; // tyle message'ow bedzie trzeba
	mpf_init(lambda);
	mpf_init(mi);
	mpf_init(t0f);
	mpf_init(t1f);
	mpf_init(t2f);
	mpf_init(t3f);
	mpf_init(kosztf);
	mpf_init(zyskf);
	mpf_init(rof);
	mpf_init(betaf);
	mpf_init(delta);
	mpf_init(q);
	mpf_init(A);
	mpf_init(m0);
	mpf_init(fcelu);
	mpf_init(fcelumax);
	mpf_init(m);
	mpf_init(pw);
	mpf_init(fcelunowa);
	mpf_init(R);
	mpf_init(maxglob);
}
void Optymalizacja::start(bool czyzysk, bool czyzadowolenie, unsigned long t0, unsigned long t1,
	unsigned long t2, unsigned long t3, double zysk, double koszt, unsigned long kas, unsigned long maxkas) {
	this->czyzysk=czyzysk;
	this->czyzadowolenie=czyzadowolenie;
	this->t0=t0;
	this->t1=t1;
	this->t2=t2;
	this->t3=t3;
	this->zysk=zysk;
	this->koszt=koszt;
	this->maxkas=maxkas;
	this->kas=kas;
	abort = false;
	QThread::start();
}

void Optymalizacja::stop() {
	abort = true;
}

void Optymalizacja::run() {
	int i, j, optkas = 1, pos = 0;
	QCustomEvent* event;
	double T, tempo;
	int konfopt, konfakt, konfzab;
	int sr;

	event = new QCustomEvent(QEvent::User, &msg[pos]);
	msg[pos++] = "Inicjalizacja zmiennych...\n";
	QThread::postEvent(obliczenia, event);

	tempo = 0.99;
	
	// koszt na sekunde
	koszt /= 3600;

	// przechodzimy na typy oferowane przez biblioteke

	mpf_set_d(t0f, t0);
	mpf_set_d(t1f, t1);
	mpf_set_d(t2f, t2);
	mpf_set_d(t3f, t3);
	mpf_set_d(zyskf, zysk);
	mpf_set_d(kosztf, koszt);

	event = new QCustomEvent(QEvent::User, &msg[pos]);
	msg[pos++] = "Obliczanie sta"+QString(QChar(322))+"ych...\n";
	QThread::postEvent(obliczenia, event);

	mpf_ui_div(lambda, 1, t0f);
	mpf_ui_div(mi, 1, t1f);
	mpf_ui_div(delta, 1, t2f);

	// zysk w jednostce czasu
	mpf_div(zyskf, zyskf, t1f);

	ro(rof, lambda, mi);
	beta1(betaf, delta ,mi);

	event = new QCustomEvent(QEvent::User, &msg[pos]);
	msg[pos++] = QString::fromLocal8Bit("rednia intensywno zgosze: "+QString::number(mpf_get_d(lambda))+"\n");
	QThread::postEvent(obliczenia, event);

	event = new QCustomEvent(QEvent::User, &msg[pos]);
	msg[pos++] = QString::fromLocal8Bit("rednia intensywno obsugi: "+QString::number(mpf_get_d(mi))+"\n");
	QThread::postEvent(obliczenia, event);

	event = new QCustomEvent(QEvent::User, &msg[pos]);
	msg[pos++] = QString::fromLocal8Bit("Wzgldna intensywno obsugi: "+QString::number(mpf_get_d(rof))+"\n");
	QThread::postEvent(obliczenia, event);


	if (kas) {		
		event = new QCustomEvent(QEvent::User, &msg[pos]);
		msg[pos++] = QString::fromLocal8Bit("\nObliczanie parametrw systemu...\n");
		QThread::postEvent(obliczenia, event);
	
		mpf_set_d(m, kas);
		sv_prawdpk(pw, kas, rof, betaf);
		wzgl_zdol_obs(q, pw);
		bezwzgl_zdol_obs(A, lambda, q);
		sr_zajetych(m0, mi, A);
		fcelu1(fcelu, m, m0, kosztf, zyskf);

		event = new QCustomEvent(QEvent::User, &msg[pos]);
		msg[pos++] = QString::fromLocal8Bit("Prawdopodobiestwo rezygnacji klienta: "+QString::number(mpf_get_d(pw))+"\n");
		QThread::postEvent(obliczenia, event);

		event = new QCustomEvent(QEvent::User, &msg[pos]);
		msg[pos++] = QString::fromLocal8Bit("Wzgldna zdolno obsugi: "+QString::number(mpf_get_d(q))+"\n");
		QThread::postEvent(obliczenia, event);

		event = new QCustomEvent(QEvent::User, &msg[pos]);
		msg[pos++] = QString::fromLocal8Bit("Bezwzgldna zdolno obsugi: "+QString::number(mpf_get_d(A))+"\n");
		QThread::postEvent(obliczenia, event);
		
		event = new QCustomEvent(QEvent::User, &msg[pos]);
		msg[pos++] = QString::fromLocal8Bit("rednia liczba zajtych kas: "+QString::number(mpf_get_d(m0))+"\n");
		QThread::postEvent(obliczenia, event);
		
		event = new QCustomEvent(QEvent::User, &msg[pos]);
		msg[pos++] = QString::fromLocal8Bit("redni zysk na godzin: "+QString::number(mpf_get_d(fcelu)*3600)+" z\n");
		QThread::postEvent(obliczenia, event);

		mpf_mul(fcelu, pw, rof);
		mpf_div(fcelu, fcelu, betaf);
		mpf_mul(fcelu, fcelu, t1f);
		mpf_div_ui(fcelu, fcelu, kas);

		event = new QCustomEvent(QEvent::User, &msg[pos]);
		msg[pos++] = QString::fromLocal8Bit("redni czas oczekiwania klientw: "+QString::number(mpf_get_d(fcelu))+" s\n");
		QThread::postEvent(obliczenia, event);

		event = new QCustomEvent(QEvent::User, &msg[pos]);
		if (mpf_cmp(fcelu, t3f)<0)
			msg[pos++] = QString::fromLocal8Bit("Wikszo klientw jest zadowolona\n");
		else
			msg[pos++] = QString::fromLocal8Bit("Wikszo klientw jest niezadowolona\n");
		QThread::postEvent(obliczenia, event);
	}
	
	// funkcja celu 1
	// symulowane wyzarzanie

	if (czyzysk || czyzadowolenie) {
		event = new QCustomEvent(QEvent::User, &msg[pos]);
		msg[pos++] = QString::fromLocal8Bit("\nRozpoczcie optymalizacji...\n");
		QThread::postEvent(obliczenia, event);
	}

	if (czyzysk) {
		event = new QCustomEvent(QEvent::User, &msg[pos]);
		msg[pos++] = "Maksymalizacja zysku...\n";
		QThread::postEvent(obliczenia, event);

		srand(0);
		for(i=0; i<5; i++) {
			konfakt = t1/t0;
			if (konfakt<100)
				konfakt = 100;
			if (konfakt > 1000)
				konfakt = 1000;
			if (konfakt > maxkas && maxkas>0)
				konfakt = maxkas;

			konfopt = konfakt; // aktualna najlepsza konfiguracja
			mpf_set_d(m, konfakt);

			if (abort)
				return;

			sv_prawdpk(pw, konfakt, rof, betaf);
			wzgl_zdol_obs(q, pw);
			bezwzgl_zdol_obs(A, lambda, q);
			sr_zajetych(m0, mi, A);
			fcelu1(fcelu, m, m0, kosztf, zyskf);
			mpf_set(fcelumax, fcelu);

			T = 10000*t1/t0;

			while (T>0.001) {
				for (;;) {
					konfzab = konfakt + rand()%9 - 4; // konfiguracja zaburzona
					if (konfzab>=1 && ((maxkas && konfzab<=maxkas) || !maxkas))
						break;
				}

				mpf_set_d(m, konfzab);

				if (abort)
					return;

				sv_prawdpk(pw, konfzab, rof, betaf);
				wzgl_zdol_obs(q, pw);
				bezwzgl_zdol_obs(A, lambda, q);
				sr_zajetych(m0, mi, A);
				fcelu1(fcelunowa, m, m0, kosztf, zyskf);
				mpf_sub(R, fcelu, fcelunowa);
			
				if (mpf_cmp_d(R, 0)<=0) { // lepsza konfiguracja
					konfakt = konfzab;
					mpf_set(fcelu, fcelunowa);
					if (mpf_cmp(fcelu, fcelumax)>0) {
						mpf_set(fcelumax, fcelu);
						konfopt = konfakt;
					}
				} else { // gorsza konfiguracja
					mpf_neg(R, R);	
					mpf_set_d(m, T);
					mpf_div(R, R, m);
					mpf_set_d(m, 1.13806);
					mpf_div_ui(m, m, (unsigned long)pow(10, 10));
					mpf_div_ui(m, m, (unsigned long)pow(10, 10));
					mpf_div_ui(m, m, (unsigned long)pow(10, 3)); // m - stala Boltzmana
					mpf_div(R, R, m);

					if (((float)(rand()%100000))/100000<=exp(mpf_get_d(R))) {
						konfakt = konfzab;
						mpf_set(fcelu, fcelunowa);
					}
				}
				T = T * tempo;
			}

			if (!i) {
				mpf_set(maxglob, fcelumax);
				optkas = konfopt;
			} else
				if (mpf_cmp(maxglob, fcelumax)<0) {
					mpf_set(maxglob, fcelumax);
					optkas = konfopt;
				}
		}
		if (mpf_cmp_d(maxglob, 0)<0) // zysk ujemny
			optkas = 0;

		event = new QCustomEvent(QEvent::User, &msg[pos]);
		msg[pos++] = "Optymalna liczba kas dla maksymalizacji zysku: "+QString::number(optkas)+"\n";
		QThread::postEvent(obliczenia, event);

		if (optkas) {
			mpf_set_d(m, optkas);
			sv_prawdpk(pw, optkas, rof, betaf);
			wzgl_zdol_obs(q, pw);
			bezwzgl_zdol_obs(A, lambda, q);
			sr_zajetych(m0, mi, A);
			fcelu1(fcelu, m, m0, kosztf, zyskf);
		
			event = new QCustomEvent(QEvent::User, &msg[pos]);
			msg[pos++] = QString::fromLocal8Bit("Prawdopodobiestwo rezygnacji klienta: "+QString::number(mpf_get_d(pw))+"\n");
			QThread::postEvent(obliczenia, event);
		
			event = new QCustomEvent(QEvent::User, &msg[pos]);
			msg[pos++] = QString::fromLocal8Bit("Wzgldna zdolno obsugi: "+QString::number(mpf_get_d(q))+"\n");
			QThread::postEvent(obliczenia, event);
		
			event = new QCustomEvent(QEvent::User, &msg[pos]);
			msg[pos++] = QString::fromLocal8Bit("Bezwzgldna zdolno obsugi: "+QString::number(mpf_get_d(A))+"\n");
			QThread::postEvent(obliczenia, event);
		
			event = new QCustomEvent(QEvent::User, &msg[pos]);
			msg[pos++] = QString::fromLocal8Bit("rednia liczba zajtych kas: "+QString::number(mpf_get_d(m0))+"\n");
			QThread::postEvent(obliczenia, event);
		
			event = new QCustomEvent(QEvent::User, &msg[pos]);
			msg[pos++] = QString::fromLocal8Bit("redni zysk na godzin: "+QString::number(mpf_get_d(fcelu)*3600)+" z\n");
			QThread::postEvent(obliczenia, event);
			
			mpf_mul(fcelu, pw, rof);
			mpf_div(fcelu, fcelu, betaf);
			mpf_mul(fcelu, fcelu, t1f);
			mpf_div_ui(fcelu, fcelu, optkas);
		
			event = new QCustomEvent(QEvent::User, &msg[pos]);
			msg[pos++] = QString::fromLocal8Bit("redni czas oczekiwania klientw: "+QString::number(mpf_get_d(fcelu))+" s\n");
			QThread::postEvent(obliczenia, event);
		
			event = new QCustomEvent(QEvent::User, &msg[pos]);
			if (mpf_cmp(fcelu, t3f)<0)
				msg[pos++] = QString::fromLocal8Bit("Wikszo klientw jest zadowolona\n");
			else
				msg[pos++] = QString::fromLocal8Bit("Wikszo klientw jest niezadowolona\n");
			QThread::postEvent(obliczenia, event);
		}

		event = new QCustomEvent(QEvent::User, &msg[pos]);
		msg[pos++] = QString::fromLocal8Bit("\n");
		QThread::postEvent(obliczenia, event);
	}

	// funkcja celu 2
	// bisekcja w poszukiwaniu granicznej liczby otwartych kas dla zadowolenia wiekszosci klientow

	if (czyzadowolenie) {
		event = new QCustomEvent(QEvent::User, &msg[pos]);
		msg[pos++] = "Zadowolenie klientw...\n";
		QThread::postEvent(obliczenia, event);
		i = 1;
		j = maxkas;
		if (!j) {
			j = 1000;
			for (;;) {
				sv_prawdpk(pw, j, rof, betaf);
				mpf_mul(fcelu, pw, rof);
				mpf_div(fcelu, fcelu, betaf);
				mpf_mul(fcelu, fcelu, t1f);
				mpf_div_ui(fcelu, fcelu, j);
				
				if (mpf_cmp(fcelu, t3f)<0)
					break;
					
				i = j;
				j *= 2;
			}
		}

		for (;;) {
			sr = (i+j)/2;
			
			if (sr==maxkas)
				break;

			if (abort)
				return;

			sv_prawdpk(pw, sr, rof, betaf);
			mpf_mul(fcelu, pw, rof);
			mpf_div(fcelu, fcelu, betaf);
			mpf_mul(fcelu, fcelu, t1f);
			mpf_div_ui(fcelu, fcelu, sr);

			if (sr>1) {

				if (abort)
					return;

				sv_prawdpk(pw, sr-1, rof, betaf);
				mpf_mul(fcelunowa, pw, rof);
				mpf_div(fcelunowa, fcelunowa, betaf);
				mpf_mul(fcelunowa, fcelunowa, t1f);
				mpf_div_ui(fcelunowa, fcelunowa, sr-1);
				if (mpf_cmp(fcelu, t3f)<0 && mpf_cmp(fcelunowa, t3f)>=0)
					break;
				else if (mpf_cmp(fcelu, t3f)<0)
					j = sr-1;
				else
					i = sr+1;
			} else {
				if (j==1)
					break;
				else {
					if (mpf_cmp(fcelu, t3f)>=0)
						sr++;
					break;
				}
			}
		}

		event = new QCustomEvent(QEvent::User, &msg[pos]);
		msg[pos++] = QString::fromLocal8Bit("Minimalna liczba kas dla zadowolenia wikszoci klientw: "+QString::number(sr)+"\n");
		QThread::postEvent(obliczenia, event);
		
		if (optkas) {
			mpf_set_d(m, sr);
			sv_prawdpk(pw, sr, rof, betaf);
			wzgl_zdol_obs(q, pw);
			bezwzgl_zdol_obs(A, lambda, q);
			sr_zajetych(m0, mi, A);
			fcelu1(fcelu, m, m0, kosztf, zyskf);
		
			event = new QCustomEvent(QEvent::User, &msg[pos]);
			msg[pos++] = QString::fromLocal8Bit("Prawdopodobiestwo rezygnacji klienta: "+QString::number(mpf_get_d(pw))+"\n");
			QThread::postEvent(obliczenia, event);
		
			event = new QCustomEvent(QEvent::User, &msg[pos]);
			msg[pos++] = QString::fromLocal8Bit("Wzgldna zdolno obsugi: "+QString::number(mpf_get_d(q))+"\n");
			QThread::postEvent(obliczenia, event);
		
			event = new QCustomEvent(QEvent::User, &msg[pos]);
			msg[pos++] = QString::fromLocal8Bit("Bezwzgldna zdolno obsugi: "+QString::number(mpf_get_d(A))+"\n");
			QThread::postEvent(obliczenia, event);
		
			event = new QCustomEvent(QEvent::User, &msg[pos]);
			msg[pos++] = QString::fromLocal8Bit("rednia liczba zajtych kas: "+QString::number(mpf_get_d(m0))+"\n");
			QThread::postEvent(obliczenia, event);
		
			event = new QCustomEvent(QEvent::User, &msg[pos]);
			msg[pos++] = QString::fromLocal8Bit("redni zysk na godzin: "+QString::number(mpf_get_d(fcelu)*3600)+" z\n");
			QThread::postEvent(obliczenia, event);
			
			mpf_mul(fcelu, pw, rof);
			mpf_div(fcelu, fcelu, betaf);
			mpf_mul(fcelu, fcelu, t1f);
			mpf_div_ui(fcelu, fcelu, sr);
		
			event = new QCustomEvent(QEvent::User, &msg[pos]);
			msg[pos++] = QString::fromLocal8Bit("redni czas oczekiwania klientw: "+QString::number(mpf_get_d(fcelu))+" s\n");
			QThread::postEvent(obliczenia, event);
		}
	}

	event = new QCustomEvent(QEvent::User, 0);
	QThread::postEvent(obliczenia, event);
}
